 /* **** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is refspoof for Mozilla.
 *
 * The Initial Developer of the Original Code is SHIMODA Hiroshi.
 * Portions created by the Initial Developer are Copyright (C) 2004
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *  Ernesto Bricca 2004/09/02
 * 
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

function initState()
{

	for (var i in _elementIDs)
	{
		node  = document.getElementById(_elementIDs[i]);
		preftype = node.getAttribute('preftype');
		initValue = node.getAttribute('prefinit');

		// needed to determine the correct format out of untyped xul
		switch (preftype)
		{
			case 'string': // textfield
				initValue = String(initValue);
				break;
			case 'int':  // radio
				initValue = Number(initValue);
				break;
			case 'boolean': // checkbox
				initValue = Boolean(Number(initValue)); // 0=false, 1=true
				break;
			default:
				break;
		}

		value = prefs.talktoPref(node.getAttribute('prefstring'), null, initValue);


		switch (preftype)
		{
			case 'string': // textfield
				node.value = value;
				break;
			case 'int':  // radio
				node.selectedIndex = value;
				node.value = value;
				break;
			case 'boolean': // checkbox
				node.checked = value;
				break;
			default:
				break;
		}
	}
	if (typeof(Startup) == 'function') {
		Startup();
	}
}

function acceptState()
{

	for (var i in _elementIDs)
	{
		node     = document.getElementById(_elementIDs[i]);
		prefstring = node.getAttribute('prefstring');
		preftype = node.getAttribute('preftype');

		switch (preftype)
		{
			case 'string':
				prefs.talktoPref(prefstring, String(node.value));
				break;
			case 'int':
				// needs to have value 0-n set in the xul
				prefs.talktoPref(prefstring, Number(node.value));
				break;
			case 'boolean':
				prefs.talktoPref(prefstring, (node.checked != false));
				break;
			default:
				break;
		}
	}
	if (typeof(Shutdown) == 'function') {
		Shutdown();
	}
	window.close();
}


/*

 to be used in the calling xul

<dialog xmlns="http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul"

		buttons="accept,cancel"
		ondialogaccept="acceptState();"
		ondialogcancel="window.close();"
		onload="initState();"

 to be used in the calling xul's .js
_elementIDs = ["tst2","tst2","tst2","tst2","tst2","tst2","tst2"];
ev with Startup / Shutdown as they get called automagically if declared :)
to set/save complex states

*/